﻿using System.IO;
using System.Threading.Tasks;
using AspNetCoreDefaultHost.Configs;
using AspNetCoreSsrTemplateEngine.DataBoundContext;
using AspNetCoreSsrTemplateEngine.Renders;
using AspNetCoreSsrTemplateEngine.Template;

namespace AspNetCoreDefaultHost.Pages.Basic
{
    public abstract class ComponentBase : IRender
    {
        protected ITemplate Template { get; set; }

        public virtual void Init()
        {
            Template = TemplateLoader.Load(this, HostConfig.RootComponentResolver);
        }

        public virtual async Task RenderAsync(IReadonlyDataBindContext dataBindContext, Stream stream)
        {
            await Template.RenderAsync(dataBindContext, stream);
        }
    }
}
