﻿using AspNetCoreSsrTemplateEngine.Template;

namespace AspNetCoreSsrTemplateEngine.DataBoundContext
{
    public interface IReadonlyDataBindContext
    {
        bool TryGetValue(string key, out object value);

        bool TryGetTemplate(string key, out ITemplate slot);

        object GetValue(string key)
        {
            TryGetValue(key, out var value);
            return value;
        }

        ITemplate GetTemplate(string key)
        {
            TryGetTemplate(key, out var slot);
            return slot;
        }

        IDataBindContext CreateCascade() => new CascadeDataBindContext(this);

        IReadonlyDataBindContext Stack(IReadonlyDataBindContext dbc) => new StackedDataBindContext(this, dbc);
    }
}
