﻿using System.Collections.Concurrent;
using AspNetCoreSsrTemplateEngine.Template;

namespace AspNetCoreSsrTemplateEngine.DataBoundContext
{
    public class SimpleDataBindContext : IDataBindContext
    {
        protected ConcurrentDictionary<string, object> ValueStore;
        protected ConcurrentDictionary<string, ITemplate> SlotStore;

        public void PutValue(string key, object value)
        {
            if (null == ValueStore) ValueStore = new ConcurrentDictionary<string, object>();
            ValueStore[key] = value;
        }

        public void PutTemplate(string key, ITemplate template)
        {
            if (null == SlotStore) SlotStore = new ConcurrentDictionary<string, ITemplate>();
            SlotStore[key] = template;
        }

        public virtual bool TryGetValue(string key, out object value)
        {
            value = null;
            return null != ValueStore && ValueStore.TryGetValue(key, out value);
        }

        public virtual bool TryGetTemplate(string key, out ITemplate slot)
        {
            slot = null;
            return null != SlotStore && SlotStore.TryGetValue(key, out slot);
        }
    }
}
