﻿using System.Diagnostics;
using System.IO;
using System.Text;
using System.Threading.Tasks;
using AspNetCoreSsrTemplateEngine.DataBoundContext;

namespace AspNetCoreSsrTemplateEngine.Renders
{
#if DEBUG
    [DebuggerDisplay("Fixed: {" + nameof(_content) + "}")]
#endif 
    internal class FixedContentRender : IRender
    {
        private readonly byte[] _buf;

#if DEBUG
        private string _content;
#endif 

        public FixedContentRender(string fixedContent)
        {
            _buf = Encoding.UTF8.GetBytes(fixedContent);
#if DEBUG
            _content = fixedContent;
#endif 
        }

        public async Task RenderAsync(IReadonlyDataBindContext dataBindContext, Stream stream)
        {
            await stream.WriteAsync(_buf, 0, _buf.Length);
        }
    }
}
