﻿using System.Diagnostics;
using System.IO;
using System.Threading.Tasks;
using AspNetCoreSsrTemplateEngine.DataBoundContext;

namespace AspNetCoreSsrTemplateEngine.Renders
{
#if DEBUG

    [DebuggerDisplay("NullRender {" + nameof(Content) + "}")]
    internal class NullRender : IRender
    {
        public string Content { get; }

        public NullRender(string content)
        {
            Content = content;
        }

        public async Task RenderAsync(IReadonlyDataBindContext dataBindContext, Stream stream)
        {
            await Task.CompletedTask;
        }
    }

#endif
}
