﻿using System.Collections.Generic;
using System.IO;
using System.Threading.Tasks;
using AspNetCoreSsrTemplateEngine.DataBoundContext;
using AspNetCoreSsrTemplateEngine.Renders;

namespace AspNetCoreSsrTemplateEngine.Template
{
    internal class SimpleTemplate : ITemplate
    {
        public IReadOnlyList<IRender> RenderSequence { get; }

        public SimpleTemplate(IReadOnlyList<IRender> renderSequence)
        {
            RenderSequence = renderSequence;
        }

        public async Task RenderAsync(IReadonlyDataBindContext dataBindContext, Stream stream)
        {
            foreach (var render in RenderSequence)
            {
                await render.RenderAsync(dataBindContext, stream);
            }
        }
    }
}
